# Get Params
$Name = "Kursat"
$Surname = "Ari"
$Password = "SecurePassword!"
$CustomerOUName = "Contoso Users"
$SecondaryGroupName = "Contoso Tum Kullanicilar"

# Get Username
$Username = $Surname + $Name.Remove(1)
$Username = $Username.ToLower()

# Get AD Information
$ADDomain = [System.DirectoryServices.ActiveDirectory.Domain]::GetCurrentDomain()
$ADDomainName = $ADDomain.Name
$ADServer = ($ADDomain.InfrastructureRoleOwner.Name.Split(".")[0])
$FQDN = "DC=" + $ADDomain.Name -Replace("\.",",DC=")

# Get LDAP Information
$ADDomain = [ADSI] "LDAP://$ADServer/$FQDN"
$CustomerOU = [ADSI] "LDAP://OU=$CustomerOUName,$FQDN"
$UserDN = [ADSI] "LDAP://CN=$Name $Surname,OU=$CustomerOUName,$FQDN"

# Check Username
if ($UserDN.CN -ne $Null)
{
	$UserCN = "$Name $Surname 2"
	
	# Get Username
	$Username = $Surname + $Name.Remove(2)
	$Username = $Username.ToLower()
}
else
{
	$UserCN = "$Name $Surname"
}

# Check Username Max Character
if ($Username.Length -gt "20")
{
	$Username = $Username.Remove(20)
}

# Create AD User
$AddADUser = $CustomerOU.Create("User","CN=$UserCN")
$UserProcess = $AddADUser.Put("sAMAccountName", "$Username")
$UserProcess = $AddADUser.Put("GivenName", "$Name")
$UserProcess = $AddADUser.Put("SN", "$Surname")
$UserProcess = $AddADUser.SetInfo()

# Set User Password
$UserProcess = $AddADUser.SetPassword($Password)
$UserProcess = $AddADUser.SetInfo()

# Set Account Active
$UserProcess = $AddADUser.Psbase.Invokeset("AccountDisabled", "False")
$UserProcess = $AddADUser.SetInfo()

# Set Password is never Expired
$UserProcess = $AddADUser.Put("userAccountControl", "65536")
$UserProcess = $AddADUser.SetInfo()

# Add to Secondary Group
$UserProcess = $SecondaryGroup = [ADSI]"LDAP://CN=$SecondaryGroupName,OU=$CustomerOUName,$FQDN"
$UserProcess = $SecondaryGroup.Add([String]($AddADUser.AdsPath))