# Set Error Action
$ErrorActionPreference = "silentlycontinue"

# Check Password
if ($PoSHPost.PasswordSignUp_Confirm -ne $PoSHPost.PasswordSignUp -or !$PoSHPost.PasswordSignUp)
{
	$PasswordSignUp = "Password1!"
	$DefaultPassword = "0"
}
else
{
	$PasswordSignUp = $PoSHPost.PasswordSignUp
	$DefaultPassword = "1"
}

# Get Params
$Name = $PoSHPost.NameSignUp
$Surname = $PoSHPost.SurnameSignUp
$Password = $PasswordSignUp
$CustomerOUName = "Contoso Users"
$SecondaryGroupName = "Contoso Tum Kullanicilar"

if ($Name -and $Surname)
{
	# Get Username
	$Username = $Surname + $Name.Remove(1)
	$Username = $Username.ToLower()

	# Get AD Information
	$ADDomain = [System.DirectoryServices.ActiveDirectory.Domain]::GetCurrentDomain()
	$ADDomainName = $ADDomain.Name
	$ADServer = ($ADDomain.InfrastructureRoleOwner.Name.Split(".")[0])
	$FQDN = "DC=" + $ADDomain.Name -Replace("\.",",DC=")

	# Get LDAP Information
	$ADDomain = [ADSI] "LDAP://$ADServer/$FQDN"
	$CustomerOU = [ADSI] "LDAP://OU=$CustomerOUName,$FQDN"
	$UserDN = [ADSI] "LDAP://CN=$Name $Surname,OU=$CustomerOUName,$FQDN"

	# Check Username
	if ($UserDN.CN -ne $Null)
	{
		$UserCN = "$Name $Surname 2"
		
		# Get Username
		$Username = $Surname + $Name.Remove(2)
		$Username = $Username.ToLower()
	}
	else
	{
		$UserCN = "$Name $Surname"
	}

	# Check Username Max Character
	if ($Username.Length -gt "20")
	{
		$Username = $Username.Remove(20)
	}

	# Create AD User
	$AddADUser = $CustomerOU.Create("User","CN=$UserCN")
	$UserProcess = $AddADUser.Put("sAMAccountName", "$Username")
	$UserProcess = $AddADUser.Put("GivenName", "$Name")
	$UserProcess = $AddADUser.Put("SN", "$Surname")
	$UserProcess = $AddADUser.SetInfo()

	# Set User Password
	$UserProcess = $AddADUser.SetPassword($Password)
	$UserProcess = $AddADUser.SetInfo()

	# Set Account Active
	$UserProcess = $AddADUser.Psbase.Invokeset("AccountDisabled", "False")
	$UserProcess = $AddADUser.SetInfo()

	# Set Password is never Expired
	$UserProcess = $AddADUser.Put("userAccountControl", "65536")
	$UserProcess = $AddADUser.SetInfo()

	# Add to Secondary Group
	$UserProcess = $SecondaryGroup = [ADSI]"LDAP://CN=$SecondaryGroupName,OU=$CustomerOUName,$FQDN"
	$UserProcess = $SecondaryGroup.Add([String]($AddADUser.AdsPath))
}

if ($DefaultPassword -eq "0")
{
@"
<!DOCTYPE html>
<!--[if lt IE 7 ]> <html lang="en" class="no-js ie6 lt8"> <![endif]-->
<!--[if IE 7 ]>    <html lang="en" class="no-js ie7 lt8"> <![endif]-->
<!--[if IE 8 ]>    <html lang="en" class="no-js ie8 lt8"> <![endif]-->
<!--[if IE 9 ]>    <html lang="en" class="no-js ie9"> <![endif]-->
<!--[if (gt IE 9)|!(IE)]><!--> <html lang="en" class="no-js"> <!--<![endif]-->
    <head>
        <meta charset="UTF-8" />
        <!-- <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">  -->
        <title>Contosobank - New AD User Form</title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0"> 
        <meta name="description" content="Contosobank New AD User Form" />
        <meta name="keywords" content="Contosobank, ad user, new user, user form" />
        <link rel="stylesheet" type="text/css" href="css/demo.css" />
        <link rel="stylesheet" type="text/css" href="css/style.css" />
		<link rel="stylesheet" type="text/css" href="css/animate-custom.css" />
    </head>
    <body>
        <div class="container">
            <header>
            </header>
            <section>				
                <div id="container_demo">
                    <div id="wrapper">
                        <div id="login" class="animate form">
							<h1> User Registered! </h1>
							<p>First Name: $($Name)</p>
							<p>Last Name: $($SurName)</p>
							<p>Password: "DefaultPassword"</p>
							<p>User Logon Name: ContosoTR\$($Username)</p>
                        </div>
                    </div>
                </div>  
            </section>
        </div>
    </body>
</html>
"@
}
else
{
@"
<!DOCTYPE html>
<!--[if lt IE 7 ]> <html lang="en" class="no-js ie6 lt8"> <![endif]-->
<!--[if IE 7 ]>    <html lang="en" class="no-js ie7 lt8"> <![endif]-->
<!--[if IE 8 ]>    <html lang="en" class="no-js ie8 lt8"> <![endif]-->
<!--[if IE 9 ]>    <html lang="en" class="no-js ie9"> <![endif]-->
<!--[if (gt IE 9)|!(IE)]><!--> <html lang="en" class="no-js"> <!--<![endif]-->
    <head>
        <meta charset="UTF-8" />
        <!-- <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">  -->
        <title>New AD User Form</title>
        <meta name="viewport" content="width=device-width, initial-scale=1.0"> 
        <meta name="description" content="New AD User Form" />
        <meta name="keywords" content="ad user, new user, user form" />
        <link rel="stylesheet" type="text/css" href="css/demo.css" />
        <link rel="stylesheet" type="text/css" href="css/style.css" />
		<link rel="stylesheet" type="text/css" href="css/animate-custom.css" />
    </head>
    <body>
        <div class="container">
            <header>
            </header>
            <section>				
                <div id="container_demo">
                    <div id="wrapper">
                        <div id="login" class="animate form">
							<h1> User Registered! </h1>
							<p>First Name: $($Name)</p>
							<p>Last Name: $($SurName)</p>
							<p>Password: ***********</p>
							<p>User Logon Name: CONTOSO\$($Username)</p>
                        </div>
                    </div>
                </div>  
            </section>
        </div>
    </body>
</html>
"@
}